ROHTO BUGS - Bug #1028

[ESS-LEAVE] validasi untuk backdate maksimal 14 hari tetapi terkadang masih bisa memilih lebih di

backdate 15,16 dst
04/07/2022 03:10 PM - Muhammad Bintar

Status: Closed Start date:
Priority: Normal Due date:
Assignee: M Azid Wahyudi % Done:

Category: Estimated time:

Target version: Spent time:

04/07/2022
04/11/2022
0%

0.00 hour
1.00 hour

Description

maka bisa terpilih padahal seharusnya tidak bisa.
dear tim developer mohon support nya untuk fixing pada pemilihan tanggal startdate dimana jika memilih backdate di hari ke 15 dst
History

#1 - 04/08/2022 11:06 AM - M Azid Wahyudi
- Status changed from New to QA Test
- Assignee changed from M Azid Wahyudi to Muhammad Bintar

dear masbintar , udah bisa di cek ya
perubahan ada di bizproc -> id = 'leave_sj' di method saja perubahannya seperti dibawah ini

function getDateDifference(dateFrom, dateTo, differentType) {
var year = dateFrom.substring(0, 4);

var month = dateFrom.substring(4, 6);

var day = dateFrom.substring(6, 8);

var df = new Date(year, month - 1, day);

year = dateTo.substring(0, 4);

month = dateTo.substring(4, 6);

day = dateTo.substring(6, 8);

var dt = new Date(year, month - 1, day);

var diff = 0;

if (differentType === 'day’) {

var diffDays = (dt.getTime() - df.getTime()) / (1000 * 60 * 60 * 24);
diff = diffDays;
} else if (differentType === 'month’) {

var months;

months = (dt.getFullYear() - df.getFullYear()) * 12;

months -= df.getMonth();

months += dt.getMonth();

diff = months;

} else {

var diffYears = (dt.getFullYear() - df.getFullYear());

diff = diffYears;

}

return diff;

}

function prorateMNC() {

var Body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();

var gstartdate = Body.down('[name=QuotaStartDate]').getValue();

var gstartdate_2 = Body.down([name=QuotaStartDate2]').getValue();
var remaining_quota = Body.down('[name=RemainQuota]').getValue();
var remaining_quota_show = Body.down('[name=RemainQuotal');

var remaining_quota_2 = Body.down('[name=RemainQuota2]').getValue();
var remaining_quota_2_show = Body.down('[name=RemainQuota2]');
var leave_quota = Body.down('[name=0OriginalQuotal');

var quota_taken = Body.down('[name=QuotaTaken]');

var total_remaining_quota = Body.down('[name=TotalRemainingQuota]');
var leave_quota_2 = Body.down('[name=0OriginalQuota2]');

var total_remaining_quota_2 = Body.down('[name=TotalRemainingQuota2]'’);
var quota_taken_2 = Body.down('[name=QuotaTaken2]’);

var start_cuti = Body.down('[name=StartDate]').getValue();

var now = Ext.Date.format(new Date(), 'Ymd');

var gprorate = getDateDifference(qstartdate, start_cuti, 'month’) + 1;

if (qprorate >= 12) {

gprorate = leave_quota.getValue();

}

var gprorate_2 = 0;

if (IExt.isEmpty(qgstartdate_2)) {

gprorate_2 = getDateDifference(qgstartdate_2, start_cuti, 'month’) + 1;
}

if (gprorate_2 >=12) {

gprorate_2 = leave_quota_2.getValue();

}

var quotapernahdiambil = parselnt(leave_quota.getValue()) - parselnt(remaining_quota);
var quotapernahdiambil_2 = parselnt(leave_quota_2.getValue()) - parselnt(remaining_quota_2);
varrs = 0;

var trs = 0;

var gtaken = 0;

var sisapengambilancuti1 = 0;

if (gprorate < leave_quota.getValue()) {

rs = gprorate - quotapernahdiambil;

trs = rs - quota_taken.getValue();

if (trs < 0 && gprorate_2 > 0) {

trs = 0;

sisapengambilancuti1 = parselnt(quota_taken.getValue()) - rs;
quota_taken.setValue(rs);
total_remaining_quota.setValue(remaining_quota - parselnt(quota_taken.getValue()));
}

remaining_quota_show.setValue(rs);
total_remaining_quota.setValue(trs);

} else {

rs = remaining_quota;

trs = total_remaining_quota.getValue();
remaining_quota_show.setValue(rs);
total_remaining_quota.setValue(trs);

}

if (IExt.isEmpty(leave_quota_2.getValue()) && gprorate_2 < leave_quota_2.getValue()) {
rs = qprorate_2 - quotapernahdiambil_2;

gtaken = parselnt(quota_taken_2.getValue()) + sisapengambilancutii;
quota_taken_2.setValue(gtaken);
total_remaining_quota_2.setValue(remaining_quota_2 - gtaken);

trs = rs - gtaken;

remaining_quota_2_show.setValue(rs);
total_remaining_quota_2.setValue(trs);

} else if (IExt.isEmpty(leave_quota_2.getValue())) {

rs = remaining_quota_2;

gtaken = parselnt(quota_taken_2.getValue()) + sisapengambilancutii;
quota_taken_2.setValue(gtaken);
total_remaining_quota_2.setValue(remaining_quota_2 - gtaken);
trs = total_remaining_quota_2.getValue();
remaining_quota_2_show.setValue(rs);
total_remaining_quota_2.setValue(trs);

}

1

function calculateCutiKhusus(formLeave, langid) {

var formValue = formLeave.getValues();

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var reg = MinovaUti. WORKFLOW.getRegld();

var regld = 0;

if (reg !=="") {

regld = parselnt(reg);

1

MinovaUltil.ExecuteParamQuery({

ID: "LeaveCutiKhususTUGU",

absenceType: formValue.AbsenceType,

stLeave: formValue.StartDate,

endLeave: formValue.EndDate,

empld: MinovaUti. WORKFLOW.getEmpld(),

regld: regld,

langid: MinovaUtil.GetLangID()

}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));
formLeave.setValues(dt?);

}, function (f) {});

1

function leaveDetailandBlock(formLeave, langid) {

var formValue = formLeave.getValues();

var body = MinovaUti. WORKFLOW.getViewBodyWorkflow();
var reg = MinovaUtil. WORKFLOW.getRegld();

var regld = 0;

if (reg !=="") {

regld = parselnt(reg);

1

MinovaUtil.ExecuteParamQuery({

ID: "LeaveDetailBlock",

absenceType: formValue.AbsenceType,

stLeave: formValue.StartDate,

endLeave: formValue.EndDate,

empld: MinovaUtil. WORKFLOW.getEmpld(),

regld: regld,

langid: MinovaUtil.GetLangID(),

leaveBlockList: 'AL1|AL2|AL3|AL4"

}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));

if (dt®.WarningType === "1") {

MinovaMessageError("Error", dt®.WarningText, "");
body.down('[name=StartDate]').setValue(");

}else {

formLeave.setValues(dt?);

1

}, function (f) {});

1

function setQuotaForm(field) {

try {

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var forms = body.down('form’).getForm();

var absenceType = body.down([name=AbsenceType]');

var quotaDeduction = absenceType.dispIayTpIDataQ.QuotaDeduction;
var formLeave = body.down(‘form[name=PDSWFMDLEAVE]').getForm();
var formValue = formLeave.getValues();

if (quotaDeduction 'Y") {

if ((formValue.AbsenceType ! ") && (formValue.StartDate |==") && (formValue.EndDate !==")) {
leaveDetailandBlock(forms);

1

}else {

calculateCutiKhusus(forms);

1

} catch (scombo) {}

1

function leaveCheckDate(field, empid, sdt, edt, reg_id, langid) {
var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var absenceType = body.down('[name=AbsenceType]').getValue();
var stLeave = body.down('[name=StartDate]').getValue();
MinovaUltil.ExecuteParamQuery({

ID: 'LeaveCheckDate',

emp_id: empid,

start_date: sdt,

end_date: edt,

reg_id: reg_id,

langid: MinovaUltil.GetLangID()

}, function (s) {

var obj = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(obj.data));

if (dt’.res == "1") {
body.down('[name=StartDate]').setValue(");
MinovaMessageError("Error", dt®.code, "");

} else {

setQuotaForm();

}

}, function (f) {});

}

function calculate(field) {

var reg = MinovaUti. WORKFLOW.getRegld();
var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var taskid = MinovaUti. WORKFLOW.getTaskld();
var sDate = body.down('field[name=StartDate]');
var eDate = body.down('field[name=EndDate]');
var empid = MinovaUti. WORKFLOW.getEmpld();
var reg_id = 0;

var sdt = sDate.getValue();

var edt = eDate.getValue();

var langid = MinovaUtil. SESSIONS.LangID;

if (reg !="" && reg != undefined) {

reg_id = parselnt(reg);

}

if (sdt I="" && edt |= " && sdt |= undefined && edt != undefined) {
leaveCheckDate(field, empid, sdt, edt, reg_id, langid);

}

}

function selectDate(field, combo) {

var me = this;

var now = Ext.Date.format(new Date(), 'Ymd');

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var absenceType = body.down('[name=AbsenceType]').getValue();
var stLeave = body.down('[name=StartDate]').getValue();
var taskid = MinovaUti. WORKFLOW.getTaskld();

if (taskid === 'create’ || taskid === "start') {

MinovaUtil. ExecuteParamQuery({

ID: "LeaveCheckBackdate",

startDate: stLeave,

absenceType: absenceType,

langld: MinovaUtil.GetLangID()

}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));

if (dt%res ==="1") { /I penambahan validasi
MinovaMessageError("Error", dt’.code, "");
body.down('[name=StartDate]').setValue(");

} else { // end penambahan validasi
changeDateRange(combo);

}

}, function (f) {})

} else {

changeDateRange(combo);

}

}

function fillEndDate(field, combo) {

var body = MinovaUti. WORKFLOW.getViewBodyWorkflow();
var absenceType = body.down('[name=AbsenceType]').getValue();
var stLeave = body.down('[name=StartDate]').getValue();

var taskid = MinovaUtil. WORKFLOW.getTaskld();

if (taskid === 'create' || taskid === 'start’) {
MinovaUltil.ExecuteParamQuery({

ID: "LeaveAutofillEndDateTUGU",

EmployeelD: MinovaUti. WORKFLOW.getEmpld(),
AbsenceType: absenceType,

StartDate: stLeave
}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));
body.down([name=EndDate]').setValue(dt’.EndDate);
}, function (f) {});

}

}

function changeDateRange(field, combo) {

var me = this;

var now = Ext.Date.format(new Date(), 'Ymd');

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();

var absenceType = body.down('[name=AbsenceType]').getValue();

var stLeave = body.down('[name=StartDate]').getValue();
calculate(field);

}

function changeDelegate(field) {

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var DelegateTo = body.down('[name=DelegateTo]').getValue();
MinovaUtil. ExecuteParamQuery({

ID: "LeaveAutofillDelegateTUGU",

EmployeelD: MinovaUti. WORKFLOW.getEmpld(),

Now: MinovaUtil.GetNowDate()

}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));

if (dt.length > 0) {

body.down([name=DelegateName]).setValue(dt®.DelegateName);

} else {
body.down('[name=DelegateName]').setValue(");

}

}, function (f) {});

1

function getFormHeader() {
console.log('>>getFormHeader');

var formHeader = Ext.ComponentQuery.query('wf-request-formHeader")[0];

if (formHeader !== undefined) {

formHeader = Ext.ComponentQuery.query(‘wf-request-formHeader')[0].getForm().getValues();

} else {

formHeader = Ext.ComponentQuery.query(‘wf-run-formHeader')[0].getForm().getValues();

}

console.log('<<getFormHeader');

return formHeader;

}

function selectAbsenceType(combo, field) {

var me = this;

var empld = MinovaUti. WORKFLOW.getEmpld();

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var now = Ext.Date.format(new Date(), 'Ymd');

var absenceType = body.down('[name=AbsenceType]').getValue();
combo.up().up().query('textfieId[name:AbsenceQuotaType]')[O].setVaIue(combo.displayTpIDatag.AbsenceType);
body.down([name=QuotaDeduction]').setValue(combo.display TplData’. QuotaDeduction);

MinovaUtil. ExecuteParamQuery({

ID: 'LeaveBlockContinue',

Employeeld: empld,

QuotaType: combo.display TplData’. AbsenceType

}, function (s) {

var obj = Ext.decode(s.responseText).data®;
body.down('[name=BlockContain]').setValue(obj.result);
}, function (f) {});

changeDateRange(combo);

1

function expandAbsenceType(field, eOpts) {

var me = this;

var empld = MinovaUti. WORKFLOW.getEmpld();
field.store.load({

params: {

emp_id: empld

1

D;

1

function CekLvDate() {

debugger;

var body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();
var emp = MinovaUtil. WORKFLOW.getEmpld();

var StartDate = body.down('field[name=StartDate]').getValue();
varLv=";

varlv2 =";

MinovaUtil.ExecuteParamQuery({

ID: 'LVCKDATE',

StartDate: StartDate,

EmplID: emp

}, function (s) {

d

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));

if (dt.length == 0) {

Lv=";

} else {

var val = dt®. Tglrovr;

var val2 = dt®. Tglrun;

Lv = val;

Iv2 = val2;

1

D

if (Lv=="1"){

MinovaMessageError("ERROR", "CEK19LV", "', "");
body.down('field[name=StartDate]').setValue(");
body.down('field[name=EndDate]').setValue(");
}elseif (Iv2 =="1") {
MinovaMessageError("ERROR", "CEKRUNLV", ", "");
body.down('field[name=StartDate]').setValue(");
body.down('fieldlname=EndDate]').setValue(");
1

}
function CekLvMin() {

var Body = MinovaUtil. WORKFLOW.getViewBodyWorkflow();

var ttlquo = Body.down('[name=TotalRemainingQuotal').getValue();
if (ttlquo < 0) {

MinovaMessageError("ERROR", "CEKLVQUQ", ", "");
Body.down('field[name=EndDate]').setValue(");

}

1
function CutiThn() {

var body = MinovaUti. WORKFLOW.getViewBodyWorkflow();

var abs = body.down('[name=AbsenceType]').getValue();

var StartDate = body.down('[name=StartDate]');

var StartD = body.down('[name=StartDate]').getValue();

var EndDate = body.down('[name=EndDate]');

var ss = '19000101";

var ee = '99991231";

var now = MinovaUtil. GetNowDate();

var abss = body.down('[name=TotalAbsenceTaken]');

varres =";

MinovaUtil. ExecuteParamQuery({

ID: 'CEKTWOWEEKLEAVE'

}, function (s) {

var result = Ext.decode(s.responseText);

var dt = Ext.decode(Ext.decode(result.data));

var val = di%res;

res = val;

D;

if (abs =="'1000") {

StartDate.setMinValue(res.substring(6, 8) + /' + res.substring(4, 6) + '/' + res.substring(0, 4));
StartDate.setMaxValue(ee.substring(6, 8) + /' + ee.substring(4, 6) + '/' + ee.substring(0, 4));
EndDate.setMinValue(StartD.substring(6, 8) + /' + StartD.substring(4, 6) + '/' + StartD.substring(0, 4));
EndDate.setMaxValue(ee.substring(6, 8) + /' + ee.substring(4, 6) + '/ + ee.substring(0, 4));
}else {

StartDate.setMinValue(ss.substring(6, 8) + '/' + ss.substring(4, 6) + '/' + ss.substring(0, 4));
EndDate.setMaxValue(ee.substring(6, 8) + /' + ee.substring(4, 6) + '/ + ee.substring(0, 4));
}

}

#2 - 04/08/2022 01:57 PM - Muhammad Bintar
- Status changed from QA Test to Deploy

oke sudah deployy

#3 - 04/08/2022 01:58 PM - Muhammad Bintar
- Status changed from Deploy to Closed
- Assignee changed from Muhammad Bintar to M Azid Wahyudi
clipboard-202204071501-oobgm.png 85.6 KB 04/07/2022 Muhammad Bintar
bandicam 2022-04-07 14-57-38-833.mp4 1.79 MB 04/07/2022 Muhammad Bintar
